#!/bin/bash
#. ./MT569_Config.sh
. ./CommonFunction.sh

#Get swift oontent
#parameter:1->swift file name,2->ref tag,3->ref tag qualifier
#result:processed varaible "content"
function GetAllSeq()
{
	content=""
	for seq in "${AllSeq[@]}"
	do
		currentSeq=(`echo $seq`)
		FlatFile="${currentSeq[1]}"
		startLineNums=`awk -F: -v var1="${currentSeq[0]}" '{if(var1==$3 && "16R"==$2){print NR}}' $swiftFile`
		startLineArr=(`echo $startLineNums`)
		for startLineNum in "${startLineArr[@]}"
		do
			endLineNum=""
			endLineNum=`(awk -F: -v var1="$startLineNum" '{if(NR>var1 && "16R"==$2){print NR}}' $swiftFile | head -n 1)`
			test -z "$endLineNum" && endLineNum=`(awk -F: -v var1="$startLineNum" '{if(NR>var1 && "16S"==$2){print NR}}' $swiftFile | head -n 1)`
			GetContent
		done
	done
	content="${content#*|}|"	
	test -e "$FlatFile" || touch "$FlatFile"
	echo "$content" >> "$FlatFile"
	#echo "content:$content"
	return $?
}

#Get repetitive sequence swift oontent
#parameter:1->swift file name
#result:processed varaible "content"
function GetRepetitiveSeq()
{
	refInfoArrIndex=0
	for seq in "${RepetitiveSeq[@]}"
	do
		refInfo="${refInfoArr[$refInfoArrIndex]}"
		refTag=`echo "$refInfo" | awk -F '|' '{print $1}'`
		refQualifier=`echo "$refInfo" | awk -F '|' '{print $2}'`
		refValue=`echo "$refInfo" | awk -F '|' '{print $3}'`
		currentRefArr=("${nextRefArr[@]}")
		test -z "$refValue" -a -z "$refTag" -a -z "$refQualifier" || nextRefArr=()
		currentSeq=(`echo $seq`)
		FlatFile="${currentSeq[1]}"
		test -e "$FlatFile" || touch "$FlatFile"
		startLineNums=`awk -F: -v var1="${currentSeq[0]}" '{if(var1==$3 && "16R"==$2){print NR}}' $swiftFile`
		startLineArr=(`echo $startLineNums`)
		endLineNums=`awk -F: -v var1="${currentSeq[0]}" '{if(var1==$3 && "16S"==$2){print NR}}' $swiftFile`
		endLineArr=(`echo $endLineNums`)
		lineNumIndex=0
		for startLineNum in "${startLineArr[@]}"
		do
			content=""
			endLineNum=""
			endLineNum=`(awk -F: -v var1="$startLineNum" '{if(NR>var1 && "16R"==$2){print NR}}' $swiftFile | head -n 1)`
			test -z "$endLineNum" && endLineNum=`(awk -F: -v var1="$startLineNum" '{if(NR>var1 && "16S"==$2){print NR}}' $swiftFile | head -n 1)`
			GetContent
			GetRefValue
			content="$currentRefValue|${content#*|}|"
			let lineNumIndex+=1
			echo "$content" >> "$FlatFile"
		done
		let refInfoArrIndex+=1
	done
	return 0
}

#Get swift content
#parameter:1->swift file name
#result:swift content
function GetContent()
{
	for tag in "${currentSeq[@]}"
        do
		if [ "$tag" == "${currentSeq[0]}" ]
                then
			#echo "Begin to process sequence $tag."
                	continue
                elif [ "$tag" == "${currentSeq[1]}" ]
		then
			continue
		else
                        speMapTagIndex=`echo "$tag" | awk -F: '{print $2}'`;
                        tag="${tag%:*}"
                        if [ -z "$speMapTagIndex" ]
                        then
				qualifier=""
				isContainQualifier=1
                                GetValue
                        else
                                qualifierArr=(`echo ${SpecialMappingTag[$speMapTagIndex]}`)
                                isContainQualifier=0
                                for qualifier in "${qualifierArr[@]}"
                                do
                                        GetValue
                                done
                        fi
                fi
	done
}

#Get tag value
#parameter:1->swift file name 2->tag name
#result:processed varaible "content"
function GetValue()
{
	swiftValue=""
	lineNum=""
	nextLineNum=""
	test "$isContainQualifier" == "0" && lineDetail=`awk -F '[:/]' -v var1="$startLineNum" -v var2="$endLineNum" -v var3="$qualifier" '{if(NR>var1 && NR<var2 && $4==var3){print $2,NR,$6}}' "$swiftFile" | awk "/^$tag/{print}"` || lineDetail=`awk -F '[:/]' -v var1="$startLineNum" -v var2="$endLineNum" '{if(NR>var1 && NR<var2){print $2,NR,$3}}' "$swiftFile" | awk "/^$tag/{print}"`
	if [ -n "$lineDetail" ]
        then
		lineDetailArr=(`echo $lineDetail`)
		temp="${lineDetail#* }"
		[ -z "$qualifier" -o "$qualifier" == "$refQualifier" ] && [ "$tag" == "$refTag" ] && nextRefArr=("${nextRefArr[@]}" "${endLineArr[$lineNumIndex]}|${temp#* }")
		lineNum="${temp%% *}"
                nextLineNum=`awk -v var1="$lineNum" -v var2="$endLineNum" '{if(NR>var1 && NR<=var2 && /^:/){print NR}}' "$swiftFile" | head -n 1`
		test -z "$nextLineNum" && nextLineNum=$lineNum
		GetMultiLineValue "$swiftFile" "$lineNum" "$[nextLineNum-1]" "${lineDetail%% *}" "\n" "$isContainQualifier" "$qualifier"
	else
		ProcessSwiftValue "$tag" "" "$qualifier"
		content="${content}|${swiftValue}"
        fi
}



#Get reference value
#parameter:1->end line number
#result:reference value
GetRefValue()
{
	currentRefValue=""
	test -n "$refValue" && currentRefValue="$refValue"&& return 0
	for currentRef in "${currentRefArr[@]}"
	do
		temp=`echo "$currentRef" | awk -F '|' -v var1="${endLineArr[$lineNumIndex]}" '{if(var1<$1){print $2}}'`
		if test -z "$temp"
		then
			continue
		else
			currentRefValue="$temp"
			break
		fi
	done
}	
