#!/bin/bash
#Determine if character exist in array
#parameter: 1->array 2->character
#result: 0->exist,1-->not exist
function IsCharExistInArray()
{
        if [ `echo "$1" | grep -wq "$2" && echo 0 || echo 1` -eq 0 ]
        then
                return 0
        else
                return 1
        fi
}

#Split "StatementLine" by "|"
#parameter 1->StatementLine. Format: 6!n[4!n]2a[1!a]15d1!a3!c16x[//16x]
#result splited StatementLine
function SplitStatementLine()
{
        index=0
        length=0
        swiftValue=""
        value=""
        swiftValue="${1:$index:6}"
        let index=index+6
        value="${1:$index:1}"
	swiftValue="$swiftValue|"
        DetermineCharType $value
        if [ $? -eq 0 ]
        then
                swiftValue="$swiftValue${1:$index:4}"
                let index=index+4
        fi

        value="${1:$index:1}"
        if [ "$value" == "R" ]
        then
                length=2
        else
                length=1
        fi
        swiftValue="$swiftValue|${1:$index:$length}"
        let index=index+length

        value="${1:$index:1}"
	swiftValue="$swiftValue|"
        DetermineCharType "$value"
        if [ $? -eq  1 ]
        then
                swiftValue="$swiftValue${1:$index:1}"
                let index=index+1
        fi
        FindAlphabet "$1" "$index"
        let length=$?-index
	value=`echo "${1:$index:$length}" | sed 's/,/./g'`
	swiftValue="$swiftValue|$value"
        let index=index+length
        swiftValue="$swiftValue|${1:$index:1}"
        let index=index+1
        swiftValue="$swiftValue|${1:$index:3}"
        let index=index+3
        leftValue="${1:$index}"
        swiftValue="$swiftValue|`echo $leftValue | awk -v RS="//" 'NR==1{print}'`"
        swiftValue="$swiftValue|`echo $leftValue | awk -v RS="//" 'NR==2{print}'`"
}

#Locate index where the character is alphabet.
#paramter:1->allCharacters 2->startIndex
#result: resultIndex
function FindAlphabet()
{
        DetermineCharType "${1:$2:1}"
        if [ $? -eq 1 ]
        then
                return $2
        else
                FindAlphabet "${1}" "$[$2+1]"
        fi
}

#Determine characterType
#parameter:1->character
#result:0 means number;1 means alphabet;2 means others
function DetermineCharType()
{
        case $1 in
        [0-9]*)
        return 0
        ;;
        [a-zA-Z]*)
        return 1
        ;;
        *)
        return 2
        ;;
        esac
}


#Process value
#parameter:1->tag, 2->swiftValue
#result:processed value
function ProcessSwiftValue()
{
        case $1 in
        "25")
        if [ ${swiftType:1:3} == "940" ]
        then
                swiftValue="$swiftValue|"
        fi
        ;;
        "28C" | "28E" | "23G")
                swiftValue="`echo $2 | awk -F '/' -v OFS='|' '{print $1,$2}'`"
        ;;
        "13A" | "70E" | "20C" | "17B" | "99B" | "99" | "11A" | "70C")
                swiftValue="`echo $2 | awk -F '//' '{print $2}'`"
        ;;
        "25D" | "22F" | "22H" | "22")
                swiftValue="`echo $2 | awk -F '/' -v OFS='|' '{print $2,$3}'`"
        ;;
        "61")
                SplitStatementLine "$2"
        ;;
        "19A")
                temp="`echo $2 | awk -F '//' '{print $2}'`"
                DetermineCharType "${temp:3:1}"
                test $? -eq 1 && swiftValue="`echo "${temp:1:3}|${temp:4}" | sed 's/,/./g'`" || swiftValue="`echo "${temp:0:3}|${temp:3}" | sed 's/,/./g'`"
        ;;
        "92A" | "99A")
                temp="`echo $2 | awk -F '//' '{print $2}' | sed 's/,/./g'`"
                DetermineCharType "${temp:0:1}"
                test $? -eq 1 && temp="${temp:1}"
                case "$3" in
                "PRIC")
                        swiftValue="||$temp"
                ;;
                *)
                        swiftValue="$temp"
                ;;
                esac
        ;;
        "92C")
                swiftValue="`echo $2 | awk -F '/' -v OFS='|' '{print $2,$3}' | sed 's/,/./g'`|"
        ;;
        "92B")
                swiftValue="`echo $2 | awk -F '/' -v OFS='|' '{print $3,$4,$5}' | sed 's/,/./g'`"
        ;;
        "92")
                case "$3" in
                "PRIC")
                        swiftValue="||"
                ;;
                *)
		;;
        esac
        ;;
        "64" | "65" | "60F" | "60M" | "62F" | "62M")
                swiftValue=`echo "${2:0:1}|${2:1:6}|${2:7:3}|${2:10}" | sed 's/,/./g'`
        ;;
        "22C")
                swiftValue=`echo "${2:0:4}|${2:4:2}|${2:6:4}|${2:10:4}|${2:14:2}" | sed 's/,/./g'`
        ;;
        "98A" | "98C" | "98E")
                case "$3" in
                "PREP")
                        temp="`echo $2 | awk -F '//' '{print $2}' | awk -F '/' '{print $1}'`"
                        swiftValue=`echo "${temp:0:8}|${temp:8}" | sed 's/,/./g'`
                        temp="`echo $2 | awk -F '//' '{print $2}' | awk -F '/' '{print $2}'`"
                        DetermineCharType "${temp:0:1}"
                        test $? -eq 1 && swiftValue="$swiftValue|${temp:1}" || swiftValue="$swiftValue|$temp"
                ;;
                "VALN" | "SETT")
                        temp="`echo $2 | awk -F '//' '{print $2}'`"
                        swiftValue=`echo "${temp:0:8}|${temp:8}"`
                ;;
                "TERM" | "EXRQ")
                        temp="`echo $2 | awk -F '//' '{print $2}'`"
                        swiftValue="||`echo "${temp:0:8}|${temp:8}"`"
                ;;
                *)
                ;;
                esac
        ;;
        "98B")
                swiftValue="`echo $2 | awk -F '/' -v OFS='|' '{print $2,$3,$4,$5}'`"
        ;;
        "98")
		case "$3" in
                "PREP")
                        swiftValue="||"
                ;;
                "VALN" | "SETT")
                        swiftValue="|"
                ;;
                "TERM" | "EXRQ")
                        swiftValue="|||"
                ;;
                *)
                ;;
                esac
        ;;
        "95P" | "95Q" | "95L")
                swiftValue="`echo $2 | awk -F '//' '{print $2}'`"
        ;;
        #special process in case of slash '/' in content
        "95R" | "95" | "13B" | "13")
                #temp=${2#*/}
                #swiftValue=${temp%%/*}
                #swiftValue="$swiftValue|${temp#*/}"
                temp="${2#*/}"
                swiftValue="${temp#*/}"
        ;;
        "97A" | "97")
                #keep the same count of field with 97B
                swiftValue="||`echo $2 | awk -F '//' '{print $2}'`"
        ;;
	"97B" | "94B")
                swiftValue="`echo $2 | awk -F '/' -v OFS='|' '{print $2,$3,$4}'`"
        ;;
        "36B")
                swiftValue="`echo $2 | awk -F '/' -v OFS='|' '{print $3,$4}' | sed 's/,/./g'`"
        ;;
        "90A")
                #keep the same count of field with 90B
                swiftValue="`echo $2 | awk -F '/' '{print $3}'`"
                temp="`echo $2 | awk -F '/' '{print $4}' | sed 's/,/./g'`"
                DetermineCharType "${temp:0:1}"
                test $? -eq 1 && swiftValue="$swiftValue||${temp:1}" || swiftValue="$swiftValue||$temp"
        ;;
        "90B" | "90")
                swiftValue="`echo $2 | awk -F '/' '{print $3}'`"
                temp="`echo $2 | awk -F '/' '{print $4}' | sed 's/,/./g'`"
                swiftValue="$swiftValue|${temp:0:3}|${temp:3}"
        ;;
        *)
        ;;
        esac
}

#Get value of multiple line tag
#parameter:1->swiftFileName 2->beginLineNumber 3->endLineNumber 4->tagName 5->seperator between value
#parameter:6->isContainQualifier(0=contain;1=not contain) 7->qualifier
#result:processed value
function GetMultiLineValue()
{
        test "$6" == "0" && swiftValue=`awk "NR==$2{print}" $1 | awk -F: '{print $4}'` || swiftValue=`awk "NR==$2{print}" $1 | awk -F: '{print $3}'`
        #swiftValue=`awk "NR==$2{print}" $1 | awk -F: '{print $3}'`
        ProcessSwiftValue "$4" "$swiftValue" "$7"
        content="${content}|${swiftValue}"
        for line in `seq $[$2+1] $3`
        do
                swiftValue=`awk "NR==$line{print}" $1`
                #ProcessSwiftValue "$4" "$swiftValue"
                content="${content}$5${swiftValue}"
        done
}
