#!/bin/bash
. ./MT569_Config.sh
if [ ! -e "$ReceiveFolder" ]
then
        echo "Receive folder $ReceiveFolder does not exist."
        exit 0
fi
test ! -e "$ReceiveFolderBak" && mkdir "$ReceiveFolderBak"

. ./BasicExtraction.sh
allSwiftFile=`ls ./$ReceiveFolder`
test -z "$allSwiftFile" && echo "There is no file under ./$ReceiveFolder" && exit 0
for swiftFile in $allSwiftFile
do
        #process AllSeq
	currentFile="$swiftFile"
	swiftFile="$ReceiveFolder/$swiftFile"
        swiftType=`sed -n "1p" "$swiftFile" | awk -F ':' '{print $3}'`
        if [ "${swiftType:1:3}" != "569" ]
        then
                echo "File $swiftFile is not MT569. You can check bad file $currentFile.bad under ./$ReceiveFolderBak"
		mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.bad
                continue
        fi
	
	echo "Begin to process file $swiftFile"
	refTag="20C"
	refQualifier="SEME"
        GetAllSeq
	if [ $? -eq 0 ]
        then
                echo "File $swiftFile allSeq part extract success."
                #Process Repetitive Sequence
                refValue=`echo "${nextRefArr[0]}" | awk -F '|' '{print $2}'`
		refInfoArr=(	"||$refValue"
				"||$refValue"
				"22|COLA|$refValue"
				"95|PTYB|"
				"20C|CLTR|"
				"||"
				"||"
				"||$refValue")
		GetRepetitiveSeq	
		if [ $? -eq 0 ]
                then
                        echo "File $swiftFile repetitiveSeq extract success. You can check bak file $currentFile.win under ./$ReceiveFolderBak"
                        mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.win
                else
                        echo "File $swiftFile repetitiveSeq extract fail. You can check bad file $currentFile.partialBad under ./$ReceiveFolderBak"
			mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.partialBad
                	continue
		fi
        else
                echo "File $swiftFile allSeq extract fail. You can check bad file $currentFile.bad under ./$ReceiveFolderBak "
		mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.bad
                continue
        fi
done

for file in "${FileList[@]}"
do
	test -e "$file" && mv "$file" "$DestinationFolder"
done
#exit 0
./runloader_MT569.sh
./runloader_MT569_COLLPRTY.sh
./runloader_MT569_LINK.sh
./runloader_MT569_SUME.sh
./runloader_MT569_SUMC.sh
./runloader_MT569_TRANSDET.sh
./runloader_MT569_VALDET.sh
./runloader_MT569_SECDET.sh
./runloader_MT569_ADDINFO.sh
