#!/bin/bash
#Get valur of tag86
#parameter:1->swiftFile
#result:processed variable "content" with value of tag86
function GetTag86()
{
	lineNum86=`awk "/^:86/{print NR}" $swiftFile | tail -n 1`
	#echo lineNum86:$lineNum86
	if [ -n "$lineNum86" ]
	then	
		preLineTag=`awk "(/^:/)&&(NR<$lineNum86){print}" $swiftFile | tail -n 1 | awk -F: '{print $2}'`
		#echo "preLineTag:$preLineTag"
		if [ "$preLineTag" != "61" ]
		then
			GetMultiLineValue "$swiftFile" "$lineNum86" "$[totalLineNum-1]" "86" "\n"
		else
			content="$content|"
		fi
	else
		content="$content|"
	fi
	#echo FinalContent:$content
}

#Get value of repetitive tag
#parameter:1->swiftFile
#result:processed variable "content" with value of repetitve tags
function GetRepetitveTag()
{
	tranRefNum=`awk "/^:20/{print}" $swiftFile | awk -F: '{print $3}'`
	for tag in "${RepeatTag[@]}"
	do
		lineNums=`awk "/^:$tag/{print NR}" $swiftFile`
		lineNumArr=(`echo $lineNums`)
		for lineNum in "${lineNumArr[@]}"
		do
			swiftValue=""
			content="$tranRefNum"
			#echo lineNum:$lineNum
			nextLineNum=`awk "(/^:/)&&(NR>$lineNum){print NR}" $swiftFile | head -n 1`
			if [ -z "$nextLineNum" ]
			then
				nextLineNum=$lineNum
			fi
			GetMultiLineValue "$swiftFile" "$lineNum" "$[nextLineNum-1]" "$tag" "|"
			
			if [ "$tag" == "61" -a $[nextLineNum-lineNum] -eq 1 ]
			then
				content="$content|"
			fi
				
			nextLineTag=`awk "(/^:/)&&(NR>$lineNum){print}" $swiftFile | head -n 1 | awk -F: '{print $2}'`
			#echo nextLineTag:$nextLineTag
			if [ "$tag" == "61" -a "$nextLineTag" == "86" ]
			then
				nextTwoLineNum=`awk "(/^:/)&&(NR>$nextLineNum){print NR}" $swiftFile | head -n 1`
				if [ -z "$nextTwoLineNum" ]
				then
					nextTwoLineNum=$nextLineNum
				fi
				GetMultiLineValue "$swiftFile" "$nextLineNum" "$[nextTwoLineNum-1]" "86" "\n"
			else
				content="$content|"
			fi	
			#echo "tag${tag}:$content|"
			
			if [ "$tag" == "65" ]
			then
				echo "$content|" >> "$SubContent2File"
			elif [ "$tag" == "61" ]
			then
				echo "$content|" >> "$SubContent1File"
			fi
		done
	done
}
. ./MT940_Config.sh
if [ ! -e "$ReceiveFolder" ]
then
        echo "Receive file $ReceiveFolder does not exist."
        exit 0
fi
test ! -e "$ReceiveFolderBak" && mkdir "$ReceiveFolderBak"

. ./CommonExtract.sh
allSwiftFile=`ls ./$ReceiveFolder`
test -z "$allSwiftFile" && echo "There is no file under ./$ReceiveFolder" && exit 0
test -e "$FlatFile" || touch "$FlatFile"
test -e "$SubContent1File" || touch "$SubContent1File"
test -e "$SubContent2File" || touch "$SubContent2File"
for swiftFile in $allSwiftFile
do
        #process AllTag
	currentFile="$swiftFile"
        swiftFile="$ReceiveFolder/$swiftFile"
	swiftType=`sed -n "1p" "$swiftFile" | awk -F ':' '{print $3}'`
        if [ ${swiftType:1:3} != "940" ]
        then
		echo "File $swiftFile is not MT940. You can check bad file $currentFile.bad under ./$ReceiveFolderBak"
                mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.bad
                continue
        fi
	echo "Begin to process file $swiftFile"
	totalLineNum=`sed -n '$=' "$swiftFile"`
	GetContent
	GetTag86
	if [ $? -eq 0 ]
        then
		echo "$content|" >> "$FlatFile"
                echo "File $swiftFile allSeq part extract success."
		#Process Repetitive Tag
		GetRepetitveTag
                if [ $? -eq 0 ]
                then
			echo "File $swiftFile repetitiveSeq extract success. You can check bak file $currentFile.win under ./$ReceiveFolderBak"
                        mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.win
                else
			echo "File $swiftFile repetitiveSeq extract fail. You can check bad file $currentFile.partialBad under ./$ReceiveFolderBak"
                        mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.partialBad
                        continue
		fi
        else
		echo "File $swiftFile allSeq extract fail. You can check bad file $currentFile.bad under ./$ReceiveFolderBak "
                mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.bad
                continue
        fi
done
test -e "$FlatFile" && mv "$FlatFile" "$DestinationFolder"
test -e "$SubContent2File" && mv "$SubContent2File" "$DestinationFolder"
test -e "$SubContent1File" && mv "$SubContent1File" "$DestinationFolder"
#exit 0
./runloader_MT940.sh
./runloader_MT940_STA.sh
./runloader_MT940_FAB.sh
