#!/bin/bash
#Get value of repetitive tag
#parameter:1->swiftFile
#result:processed variable "content" with value of repetitve tags
function GetRepetitveTag()
{
	tranRefNum=`awk "/^:20/{print}" $swiftFile | awk -F: '{print $3}'`
	for tag in "${RepeatTag[@]}"
	do
		lineNums=`awk "/^:$tag/{print NR}" $swiftFile`
		lineNumArr=(`echo $lineNums`)
		for lineNum in "${lineNumArr[@]}"
		do
			swiftValue=""
			content="$tranRefNum"
			#echo lineNum:$lineNum
			nextLineNum=`awk "(/^:/)&&(NR>$lineNum){print NR}" $swiftFile | head -n 1`
			if [ -z "$nextLineNum" ]
			then
				nextLineNum=$lineNum
			fi
			GetMultiLineValue "$swiftFile" "$lineNum" "$[nextLineNum-1]" "$tag" "|"
			
			if [ "$tag" == "61" -a $[nextLineNum-lineNum] -eq 1 ]
			then
				content="$content|"
			fi
			echo "$content|" >> "$SubContent1File"
		done
	done
}

. ./MT950_Config.sh
if [ ! -e "$ReceiveFolder" ]
then
        echo "Receive file $ReceiveFolder does not exist."
        exit 0
fi
test ! -e "$ReceiveFolderBak" && mkdir "$ReceiveFolderBak"

. ./CommonExtract.sh
allSwiftFile=`ls ./$ReceiveFolder`
test -z "$allSwiftFile" && echo "There is no file under ./$ReceiveFolder" && exit 0
test -e "$FlatFile" || touch "$FlatFile"
test -e "$SubContent1File" || touch "$SubContent1File"
for swiftFile in $allSwiftFile
do
        #process AllTag
	currentFile="$swiftFile"
        swiftFile="$ReceiveFolder/$swiftFile"
        swiftType=`sed -n "1p" "$swiftFile" | awk -F ':' '{print $3}'`
	if [ "${swiftType:1:3}" != "950" ]
	then
		echo "File $swiftFile is not MT950. You can check bad file $currentFile.bad under ./$ReceiveFolderBak"
                mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.bad
                continue
	fi
	echo "Begin to process file $swiftFile"
	totalLineNum=`sed -n '$=' "$swiftFile"`
	GetContent
	if [ $? -eq 0 ]
        then
		echo "$content|" >> "$FlatFile"
                echo "File $ReceiveFolder/$swiftFile all tags extract success."
                #Process Repetitive Tag
		GetRepetitveTag
                if [ $? -eq 0 ]
                then
			echo "File $swiftFile repetitiveSeq extract success. You can check bak file $currentFile.win under ./$ReceiveFolderBak"
                        mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.win
                else
                        echo "File $swiftFile repetitiveSeq extract fail. You can check bad file $currentFile.partialBad under ./$ReceiveFolderBak"
                        mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.partialBad
                        continue
		fi
        else
		echo "File $swiftFile allSeq extract fail. You can check bad file $currentFile.bad under ./$ReceiveFolderBak "
                mv ./$swiftFile ./$ReceiveFolderBak/$currentFile.bad
                continue
        fi
done
test -e "$FlatFile" && mv "$FlatFile" "$DestinationFolder"
test -e "$SubContent1File" && mv "$SubContent1File" "$DestinationFolder"
#exit 0
./runloader_MT950.sh
./runloader_MT950_STA.sh
