/*     */ package sqlloaderaes;
/*     */ 
/*     */ import java.io.FileInputStream;
/*     */ import java.io.FileNotFoundException;
/*     */ import java.io.IOException;
/*     */ import java.util.Properties;
/*     */ import java.util.logging.Level;
/*     */ import java.util.logging.Logger;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SqlLoaderAES
/*     */ {
/*     */   public static final String PROPERTIES_FILENAME = "config.properties";
/*     */   
/*     */   public static void main(String[] args) {
/*  27 */     parseArguments(args);
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   private static void parseArguments(String[] args) {
/*  33 */     System.out.println("Arguments: ");
/*  34 */     for (int ii = 0; ii < args.length; ii++)
/*  35 */       System.out.println("arg" + ii + ": " + args[ii]); 
/*  36 */     System.out.println("");
/*     */ 
/*     */     
/*  39 */     if (args.length == 1) {
/*     */       
/*  41 */       processWrongArgsFormat();
/*     */     
/*     */     }
/*  44 */     else if (args.length == 2) {
/*     */       
/*  46 */       if (args[0].equalsIgnoreCase("Encrypt")) {
/*     */         
/*  48 */         String res = CryptoAES.encrypt(args[1]);
/*  49 */         System.out.println("Original string: " + args[1]);
/*  50 */         System.out.println("Encryption result: " + res);
/*  51 */         System.exit(0);
/*     */       }
/*  53 */       else if (args[0].equalsIgnoreCase("Run")) {
/*     */         
/*  55 */         processRun(args[1]);
/*     */       } else {
/*     */         
/*  58 */         processWrongArgsFormat();
/*     */       } 
/*     */     } else {
/*  61 */       processWrongArgsFormat();
/*     */     } 
/*     */   }
/*     */ 
/*     */   
/*     */   private static void processWrongArgsFormat() {
/*  67 */     String s = String.format("Invalid command line format! Usage as following:\nEncrypt DB_Password  : used to generate encrypted DB password\n", new Object[0]);
/*     */ 
/*     */ 
/*     */     
/*  71 */     System.err.println(s);
/*  72 */     System.exit(0);
/*     */   }
/*     */ 
/*     */   
/*     */   private static void processRun(String ctrlFile) {
/*  77 */     Properties properties = new Properties();
/*     */     try {
/*  79 */       System.out.println("Processing: " + ctrlFile);
/*  80 */       properties.load(new FileInputStream("config.properties"));
/*     */       
/*  82 */       String db_host = properties.getProperty("DB_HOSTNAME");
/*  83 */       checkPropValue(db_host);
/*  84 */       String db_port = properties.getProperty("DB_PORT");
/*  85 */       checkPropValue(db_port);
/*  86 */       String db_user = properties.getProperty("DB_USER");
/*  87 */       checkPropValue(db_user);
/*  88 */       String db_password1 = properties.getProperty("DB_PASSWORD");
/*  89 */       checkPropValue(db_password1);
/*  90 */       String db_password = CryptoAES.decrypt(db_password1);
/*     */       
/*  92 */       String db_schema = properties.getProperty("DB_SCHEMA");
/*  93 */       checkPropValue(db_schema);
/*     */       
/*  95 */       String error_allow = properties.getProperty("ERROR_ALLOWED", "2000");
/*     */ 
/*     */ 
/*     */       
/*  99 */       String cmd = "sqlldr " + db_user + "/" + db_password + "@" + db_host + ":" + db_port + "/" + db_schema + " control=" + ctrlFile + " errors=" + error_allow;
/*     */ 
/*     */ 
/*     */       
/* 103 */       Process p = Runtime.getRuntime().exec(cmd);
/*     */       
/* 105 */       StreamGobbler errGobbler = new StreamGobbler(p.getErrorStream(), "ERROR");
/* 106 */       StreamGobbler outGobbler = new StreamGobbler(p.getInputStream(), "OUTPUT");
/*     */       
/* 108 */       errGobbler.start();
/* 109 */       outGobbler.start();
/*     */       
/* 111 */       p.waitFor();
/*     */       
/* 113 */       System.out.println("end");
/*     */     }
/* 115 */     catch (FileNotFoundException ex) {
/* 116 */       Logger.getLogger(SqlLoaderAES.class.getName()).log(Level.SEVERE, (String)null, ex);
/*     */     }
/* 118 */     catch (IOException ex) {
/* 119 */       System.exit(1);
/*     */     }
/* 121 */     catch (Exception ex) {
/* 122 */       System.exit(1);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private static void checkPropValue(String propValue) throws Exception {
/* 130 */     if (propValue.trim().isEmpty())
/* 131 */       throw new Exception("Invalid properties value!"); 
/*     */   }
/*     */ }


/* Location:              D:\work\workFile\PAB\WFH\WFH\SqlLoder\SqlLoaderAES.jar!\sqlloaderaes\SqlLoaderAES.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       1.1.3
 */